#!/usr/bin/perl

use Time::HiRes qw( usleep );

my $language="en";

# msghandler sub.. called by poll sub like &msghandler($buffer);

sub msghandler {
  $raw = $_[0];
  $hraw = $raw;
  $hraw = substr($hraw,1,length($hraw)-1);
  @qwerty=split(/ :/,$hraw,2);
  $inmsg = $qwerty[1];
  @uiop = split(' PRIVMSG ', $qwerty[0], 2);
  $inchan=$uiop[1];
  @asdfg = split(/!/, $uiop[0]);
  $innick = $asdfg[0];
  @hjkl = split('@',$asdfg[1], 2);
  $inident = $hjkl[0];
  $inhost = $hjkl[1];

  @words=split(' ',$inmsg);
  $nbwords=$#words;
  # print "nbwords=$nbwords inmsg=$inmsg\n";
  my $cword==''; 
  my $word; 
  my $iword=0;
  my $lchar;
  foreach $word (@words)
  {
     $pword = substr $word,0,2;
     if ( $pword eq "l:" )
     {
        $language = substr $word,2; 
        return;
     }
     if ( $word eq "w:help" )
     {
        &privmsg($inchan, "wikinibot :: help");
        &privmsg($inchan, "w:<word> or w:(<word1> <word2> ...)     : gets a short definition of a concept");
        &privmsg($inchan, "W:<word> or W:(<word1> <word2> ...)     : gets a long definition of a concept");
        &privmsg($inchan, "p:<word> or p:(<word1> <word2> ...)     : gets a long definition in a private window");
        &privmsg($inchan, "r:<word> or r:(<word1> <word2> ...)     : gets related concepts");
        &privmsg($inchan, "l:de|fr|es|ca|ja...                     : change the working language");
        &privmsg($inchan, "w:help                                  : this help");
        return;
     }
     if ( ( $pword eq "w:" ) || ( $pword eq "W:" )  || ( $pword eq "p:" ) || ( $pword eq "P:" )  || ( $pword eq "r:" ) || ( $pword eq "R:" )  )
     {
        my $fchar = substr $word,2,1; 
        #print ">".$fchar."<\n";
        if ( $fchar eq '(' )
        {
           #print "composed word\n";
           $cword = substr $word,3;
           for ($wi=$iword+1; $wi<=$nbwords;$wi++)
           {
             $lchar = substr $words[$wi],length($words[$wi])-1,1;
             if ( $lchar eq ')' )
             {
                $cword .= ' '.substr $words[$wi],0,length($words[$wi])-1;
                print ">".$cword."<\n";
                last;
             }
             else
             {
                $cword .= ' '.$words[$wi];
             }
           }
        }
        else
        {
           $cword = substr $word,2;
        }
        last;
     }
     $iword++;
  }
  if ( $cword eq "" )
  {
     return;
  }
  
  my $wikiasw;
  if ( ( $pword eq "r:" ) || ( $pword eq "R:" )  )
  {
    $wikiasw = `./get-related.pl $language $cword`;
  }
  else
  {
    $wikiasw = `./get-wikini.pl $language $cword`;
  }

  # print $wikiasw;
  my @lines = split( '\n', $wikiasw );
  my $line, $lchar;
  my $linecount=0;
  foreach $line (@lines)
  {
     if ( ! ( $line =~ /refer to/i ) ) 
     {
        if ( ( $pword eq "p:" ) || ( $pword eq "P:" ) )
        {
          &privmsg($innick, $line);
        }
        else
        {
          &privmsg($inchan, $line);
        }
     }
     $linecount++;
     $lchar = substr $line,length($line)-1,1;
     #print ">".$lchar."<\n";
     if ( ( $lchar eq '.' ) && ( $pword eq "w:" ) )
     {
        last;
     }
     usleep( 500000 );
  }

}

1;
