#!/usr/bin/perl

use Socket;

require "./params.pl";
require "./connect.pl";
require "./irc.pl";
require "./message.pl";

#### Change anything/everything below this point.

# Server address, fairly self-explanitory. PLEASE CHANGE!
$server = $Server;

# Bot's default nick.. 
$botnick = 'wikinibot';

# Default channels for the bot to join
# Add more in the same format
$chans[0] = $Channel;

# quit message.. also fairly obvious
$quitmsg = 'i\'m puzzled.......';

# This tells the bot who it should see as it's admin.
# my hostmask on irc is usually kieran!kieran@Admin.Ac6.Org
# so you can see how to modify this to suit yourself.
$adminhost = 'ac6.org';
$adminident = 'dregs';

#### Don't Change anything after this point unless you know
#### What you're doing.

$SIG{'INT'} = 'shutdown';

&connect;
&poll;
